REVOKE ALL ON dbo.tbl_sales FROM role_sales
go

--Now lets create a view that filters on the salesperson
CREATE OR ALTER VIEW dbo.vw_sales  AS
SELECT
	sales_id,
    sales_person,
    sales_date,
    sales_amount,
	credit_card
FROM dbo.tbl_sales
WHERE sales_person=SYSTEM_USER 


GO
GRANT SELECT,UPDATE,DELETE,insert ON dbo.vw_sales TO role_sales


















go
--Add the ability for some groups to see all rows
CREATE OR ALTER VIEW dbo.vw_sales AS
SELECT
	sales_id,
	sales_person,
	sales_date,
	sales_amount
FROM dbo.tbl_sales
WHERE sales_person=SYSTEM_USER OR COALESCE(IS_MEMBER('db_owner'),0)=1

GO





--Add the "With Check option to ensure record stays in view"
CREATE OR ALTER VIEW dbo.vw_sales AS
SELECT
	sales_id,
	sales_person,
	sales_date,
	sales_amount
FROM dbo.tbl_sales
WHERE sales_person=SYSTEM_USER OR COALESCE(IS_MEMBER('db_owner'),0)=1
WITH CHECK OPTION
GO
