--RLS 2
CREATE SCHEMA sec AUTHORIZATION dbo 
GO


CREATE FUNCTION sec.func_security_sales_person(@sales_person VARCHAR(20))
RETURNS TABLE 
--WITH SCHEMABINDING
AS Return
SELECT 1 AS row_visible
WHERE @sales_person=SYSTEM_USER


GO








CREATE SECURITY POLICY sec.sales_filter 
ADD FILTER PREDICATE sec.func_security_sales_person(sales_person) ON dbo.tbl_sales
WITH (STATE=ON,SCHEMABINDING=off) 

--Grant full rights on the TABLE
GRANT SELECT,UPDATE,INSERT,delete ON dbo.tbl_sales TO role_sales

GRANT SELECT ON schema::sec TO role_sales --User needs rights to run the function










ALTER SECURITY POLICY sec.sales_filter 
ADD block PREDICATE sec.func_security_sales_person(sales_person) ON dbo.tbl_sales





























/* Dont go here */












go
CREATE FUNCTION sec.func_security_employee(@employee_id int)
RETURNS TABLE 

AS Return
	SELECT 1 AS row_visible
	FROM tbl_employee E
	INNER JOIN tbl_department D ON E.department_id=D.department_id
	WHERE E.employee_id=@employee_id AND D.department_manager=SYSTEM_USER
go
